local uabStatus_ActionRange = uabUnitStatus:NewModule("Out of Range")
uabStatus_ActionRange.defaultDB = {
    disabled = nil,
    priority = 50,
    color = { r = 1,    g = 0.5,  b = 0, a = 1, }
}

function uabStatus_ActionRange:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus(self.name)
end

function uabStatus_ActionRange:OnEnable()
end

function uabStatus_ActionRange:OnDisable()
end

function uabStatus_ActionRange:IsStatusGained(name, unit, action)
	if name == self.name then
	    if not unit then return end
		if action and action:GetClassName() == "SpellAction" then
	        local spell = action:GetSpellName()
	    
	        if spell then
	            local inRange = IsSpellInRange(spell, unit)
	            if inRange then
	                if inRange == 1 then return end
	                return true
	            end
	        end
	    
	        -- check follow distance as the default check (~28 yards)
	        return not CheckInteractDistance(unit, 4)
	    end
	end
end

function uabStatus_ActionRange:CreateUnitStatusOptions()
    return self:CreateUnitStatusOption(self.db.profile, "Out of Range", "Out of Range")
end
